// ***********************************************************
// Project:  Pause
// Software: AVR-Studio v4.18 / WinAVR-20090313
// Author:   Edit Jens Grtler, Autor unbekannt
// Erstellt: 03.01.2012
// ***********************************************************


// --- einbinden von Libs ------------------------------------
#include <avr\io.h>                          // AVR Basisdaten einbinden

// --- Definiton der Konstanten ------------------------------
#define CRC8POLY	0x18                     // 0X18 = X^8+X^5+X^4+X^0

// --- Definiton der Globalen Variabeln ----------------------
volatile uint8_t CRC8_Sp = 0;                // CRC8 Speicher


// *************************************************************************************
// *   ROUTINE - CRC8 erstellen                                                        *
// *************************************************************************************
void CRC8_berechnen(uint8_t	crc_data) {      // Beginn CRC8 erstellen
   uint8_t  bit_counter = 8;                 // Bit Counter
   uint8_t  feedback_bit = 0;                // Feedback
   do {                                      // While 8x durchlaufen
      feedback_bit = (CRC8_Sp ^ crc_data) & 0x01;  //
      if ( feedback_bit == 0x01 ) {          //
         CRC8_Sp = CRC8_Sp ^ CRC8POLY;       //
      }                                      //
      CRC8_Sp = (CRC8_Sp >> 1) & 0x7F;       //
      if ( feedback_bit == 0x01 ) {          //
         CRC8_Sp = CRC8_Sp | 0x80;           //
      }                                      //
      crc_data = crc_data >> 1;              //
      bit_counter--;                         //
   } while (bit_counter > 0);                // Ende While
}                                            // Ende CRC8 erstellen









